diff --git a/CMakeLists.txt b/CMakeLists.txt
index de32bae7dc..9907b15a82 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -45,6 +45,7 @@ CHECK_INCLUDE_FILE("unistd.h" HAVE_UNISTD_H)
 CHECK_INCLUDE_FILE("float.h" HAVE_FLOAT_H)
 CHECK_INCLUDE_FILE("ctype.h" HAVE_CTYPE_H)
 CHECK_INCLUDE_FILE("wchar.h" HAVE_WCHAR_H)
+CHECK_INCLUDE_FILE("wctype.h" HAVE_WCTYPE_H)
 CHECK_INCLUDE_FILE("alloca.h" HAVE_ALLOCA_H)
 CHECK_INCLUDE_FILE("getopt.h" HAVE_GETOPT_H)
 CHECK_INCLUDE_FILE("stdint.h" HAVE_STDINT_H)
diff --git a/configure.ac b/configure.ac
index 0e9f3c627c..57450ba5ed 100644
--- a/configure.ac
+++ b/configure.ac
@@ -118,7 +118,7 @@ dnl We just want to know if it's needed
 ac_cv_func_malloc_0_nonnull=yes
 ac_cv_func_realloc_0_nonnull=yes
 AC_CHECK_HEADERS([stdlib.h string.h stddef.h unistd.h malloc.h wchar.h ctype.h \
-                  float.h limits.h \
+                  wctype.h float.h limits.h \
                   libgen.h getopt.h alloca.h valgrind/valgrind.h \
                   sys/param.h])
 AC_CHECK_HEADERS([endian.h sys/endian.h machine/endian.h winsock2.h \
diff --git a/examples/dwgadd.c b/examples/dwgadd.c
index 030564301f..5329e21586 100644
--- a/examples/dwgadd.c
+++ b/examples/dwgadd.c
@@ -55,6 +55,7 @@ static unsigned int loglevel;
 #  define SZ ,119
 // clang-format on
 #  define FMT_NAME "%[a-zA-Z0-9_]"
+#  define FMT_TAG "%[^ !]"
 #  define FMT_TBL "\"%[a-zA-Z0-9._ -]\""
 #  define FMT_PATH "\"%[a-zA-Z0-9_. \\-]\""
 #  define FMT_ANY "\"%[^\"]"
@@ -62,6 +63,7 @@ static unsigned int loglevel;
 #  define SSCANF_S sscanf
 #  define SZ
 #  define FMT_NAME "%119[a-zA-Z0-9_]"
+#  define FMT_TAG "%119[^ !]"
 #  define FMT_TBL "\"%119[a-zA-Z0-9._ -]\""
 #  define FMT_PATH "\"%119[a-zA-Z0-9_. \\-]\""
 #  define FMT_ANY "\"%119[^\"]\""
@@ -928,14 +930,14 @@ dwg_add_dat (Dwg_Data **dwgp, Bit_Chain *dat)
           LOG_TRACE ("mspace\n");
         }
       else if (8 == SSCANF_S (p,
-                         "attdef %lf %d " FMT_ANY " (%lf %lf %lf) " FMT_ANY
+                         "attdef %lf %d " FMT_ANY " (%lf %lf %lf) " FMT_TAG
                          " " FMT_ANY,
                          &height, &flags, prompt SZ, &pt1.x, &pt1.y,
                          &pt1.z, tag SZ, default_text SZ))
         {
           if (version < R_2_0b)
             fn_error ("Invalid entity ATTDEF <r2.0b\n");
-          LOG_TRACE ("add_ATTDEF %s %f %d \"%s\" (%f %f %f) \"%s\" \"%s\"\n",
+          LOG_TRACE ("add_ATTDEF %s %f %d \"%s\" (%f %f %f) %s \"%s\"\n",
                      hdr_s, height, flags, prompt, pt1.x, pt1.y, pt1.z,
                      tag, default_text);
           ent = (lastent_t){ .u.attdef
@@ -948,7 +950,7 @@ dwg_add_dat (Dwg_Data **dwgp, Bit_Chain *dat)
         SET_ENT (attdef, ATTDEF)
       // clang-format on
       else if (7 == SSCANF_S (p,
-                         "attrib %lf %d (%lf %lf %lf) " FMT_ANY
+                         "attrib %lf %d (%lf %lf %lf) " FMT_TAG
                          " " FMT_ANY,
                          &height, &flags, &pt1.x, &pt1.y,
                          &pt1.z, tag SZ, text SZ))
@@ -960,7 +962,7 @@ dwg_add_dat (Dwg_Data **dwgp, Bit_Chain *dat)
               log_p (DWG_LOGLEVEL_ERROR, p);
               fn_error ("Missing INSERT for ATTRIB\n");
             }
-          LOG_TRACE ("add_ATTRIB insert %f %d (%f %f %f) \"%s\" \"%s\"\n",
+          LOG_TRACE ("add_ATTRIB insert %f %d (%f %f %f) %s \"%s\"\n",
                      height, flags, pt1.x, pt1.y, pt1.z, tag, text);
           ent = (lastent_t){ .u.attrib
                              = dwg_add_ATTRIB (insert.u.insert, height,
diff --git a/examples/dwgadd.example b/examples/dwgadd.example
index 385c3c4ac6..ae1e94a7c2 100644
--- a/examples/dwgadd.example
+++ b/examples/dwgadd.example
@@ -5,11 +5,11 @@
 #version 2000
 text "test" (0.0 1.0 0.0) 8
 block "bloko"
-attdef 8 0 "prompt" (0.0 1.0 0.0) "tag" "default_text"
+attdef 8 0 "prompt" (0.0 1.0 0.0) TAG "default_text"
 line (0 1 0) (1 1 0)
 endblk
 insert (0 1 0) "bloko" 1 1 1 0
-attrib 8 0 (0.0 2.0 0.0) "tag" "text1"
+attrib 8 0 (0.0 2.0 0.0) TAG "text1"
 minsert (0 1 0) "bloko" 1 1 1 0 1 2 1 1
 minsert.rotation = 90
 polyline_2d 2 ((0 1) (1 1))
diff --git a/examples/dwgadd.example_r10 b/examples/dwgadd.example_r10
index 7884e8946b..efb027cf09 100644
--- a/examples/dwgadd.example_r10
+++ b/examples/dwgadd.example_r10
@@ -2,11 +2,11 @@
 point (2 0 0)
 text "test" (0.0 1.0 0.0) 8
 block "bloko"
-attdef 8 0 "prompt" (0.0 1.0 0.0) "tag" "default_text"
+attdef 8 0 "prompt" (0.0 1.0 0.0) TAG "default_text"
 line (0 1 0) (1 1 0)
 endblk
 insert (0 1 0) "bloko" 1 1 1 0
-attrib 8 0 (0.0 2.0 0.0) "tag" "text1"
+attrib 8 0 (0.0 2.0 0.0) TAG "text1"
 polyline_2d 2 ((0 1) (1 1))
 polyline_3d 2 ((0 1 0) (1 1 0))
 arc (0.0 1.0 0.0) 0.5 0.0 3.0
diff --git a/examples/dwgadd.example_r11 b/examples/dwgadd.example_r11
index 6a7abbc381..cfffd38539 100644
--- a/examples/dwgadd.example_r11
+++ b/examples/dwgadd.example_r11
@@ -2,11 +2,11 @@
 point (2 0 0)
 text "test" (0.0 1.0 0.0) 8
 block "bloko"
-attdef 8 0 "prompt" (0.0 1.0 0.0) "tag" "default_text"
+attdef 8 0 "prompt" (0.0 1.0 0.0) TAG "default_text"
 line (0 1 0) (1 1 0)
 endblk
 insert (0 1 0) "bloko" 1 1 1 0
-attrib 8 0 (0.0 2.0 0.0) "tag" "text1"
+attrib 8 0 (0.0 2.0 0.0) TAG "text1"
 polyline_2d 2 ((0 1) (1 1))
 polyline_3d 2 ((0 1 0) (1 1 0))
 arc (0.0 1.0 0.0) 0.5 0.0 3.0
diff --git a/examples/dwgadd.example_r2_10 b/examples/dwgadd.example_r2_10
index 0e9bec04fe..39c47dc09e 100644
--- a/examples/dwgadd.example_r2_10
+++ b/examples/dwgadd.example_r2_10
@@ -2,11 +2,11 @@
 point (2 0 0)
 text "test" (0.0 1.0 0.0) 8
 block "bloko"
-attdef 8 0 "prompt" (0.0 1.0 0.0) "tag" "default_text"
+attdef 8 0 "prompt" (0.0 1.0 0.0) TAG "default_text"
 line (0 1 0) (1 1 0)
 endblk
 insert (0 1 0) "bloko" 1 1 1 0
-attrib 8 0 (0.0 2.0 0.0) "tag" "text1"
+attrib 8 0 (0.0 2.0 0.0) TAG "text1"
 polyline_2d 2 ((0 1) (2 3))
 polyline_3d 2 ((0 1 2) (3 4 5))
 arc (0.0 1.0 0.0) 0.5 0.0 3.0
diff --git a/include/dwg_api.h b/include/dwg_api.h
index 6761290e7b..a92c4984ce 100644
--- a/include/dwg_api.h
+++ b/include/dwg_api.h
@@ -6260,6 +6260,10 @@ EXPORT int
 dwg_add_entity_defaults (Dwg_Data *restrict dwg,
                          Dwg_Object_Entity *restrict ent) __nonnull_all;
 
+/* utf-8 string without lowercase letters, space or !. maxlen 255 */
+EXPORT bool
+dwg_is_valid_tag (const char *tag);
+  
 EXPORT Dwg_Entity_TEXT*
 dwg_add_TEXT (Dwg_Object_BLOCK_HEADER *restrict blkhdr,
               const char* restrict text_value,
diff --git a/src/cmakeconfig.h.in b/src/cmakeconfig.h.in
index 0d4eb8c4fa..236d63f6e0 100644
--- a/src/cmakeconfig.h.in
+++ b/src/cmakeconfig.h.in
@@ -237,6 +237,9 @@
 /* Define if you have the `wcsnlen' function. */
 #cmakedefine HAVE_WCSNLEN
 
+/* Define if you have the <wctype.h> header file. */
+#cmakedefine HAVE_WCTYPE_H
+
 /* Define if the system has the type `_Bool'. */
 #define HAVE__BOOL 1
 
diff --git a/src/config.h.in b/src/config.h.in
index 0cd97edc9c..2e242c9e45 100644
--- a/src/config.h.in
+++ b/src/config.h.in
@@ -258,6 +258,9 @@
 /* Define to 1 if you have the `wcsstr' function. */
 #undef HAVE_WCSSTR
 
+/* Define to 1 if you have the <wctype.h> header file. */
+#undef HAVE_WCTYPE_H
+
 /* Define if -Wformat-y2k is supported. */
 #undef HAVE_WFORMAT_Y2K
 
diff --git a/src/dwg_api.c b/src/dwg_api.c
index 565b43e2d5..57deb3980c 100644
--- a/src/dwg_api.c
+++ b/src/dwg_api.c
@@ -26,6 +26,9 @@
 #include <inttypes.h>
 #include <math.h>
 #include <time.h>
+#ifdef HAVE_WCTYPE_H
+#  include <wctype.h>
+#endif
 #include <assert.h>
 
 #ifdef HAVE_MALLOC_H
@@ -23085,6 +23088,44 @@ add_attrib_links (Dwg_Object_BLOCK_HEADER *restrict blkhdr,
   return insert;
 }
 
+/* utf-8 string without lowercase letters, space or ! */
+EXPORT bool
+dwg_is_valid_tag (const char *tag)
+{
+  if (!tag || strchr (tag, ' ') || strchr (tag, '!') || strlen (tag) > 256)
+    return false;
+  {
+#ifdef HAVE_WCTYPE_H
+  // decode utf-8, check wide-chars
+    BITCODE_TU wstr = bit_utf8_to_TU ((char*)tag, 0);
+    size_t len = bit_wcs2nlen (wstr, 256);
+    if (len > 256 || !len)
+      {
+        free (wstr);
+        return false;
+      }
+    for (size_t i = 0; i < len; i++)
+      {
+        if (iswlower (wstr[i]))
+          {
+            free (wstr);
+            return false;
+          }
+      }
+    free (wstr);
+  }
+#else
+  // only ascii support, no wctype nor maxlen checks
+  while (*tag)
+    {
+      if (islower (*tag))
+        return false;
+      tag++;
+    }
+#endif
+  return true;
+}
+
 /* This adds the ATTRIB and ENDBLK to the insert,
    and the ATTDEF and ENDBLK to the block. */
 EXPORT Dwg_Entity_ATTRIB *
@@ -23100,6 +23141,11 @@ dwg_add_Attribute (Dwg_Entity_INSERT *restrict insert, const double height,
   Dwg_Entity_ATTRIB *attrib;
   int err;
 
+  if (!dwg_is_valid_tag (tag))
+    {
+      LOG_ERROR ("add_Attribute: Invalid tag %s", tag);
+      return NULL;
+    }
   ADD_CHECK_3DPOINT (ins_pt);
   ADD_CHECK_DOUBLE (height);
   insobj = dwg_obj_generic_to_object (insert, &err);
@@ -23149,6 +23195,13 @@ dwg_add_ATTRIB (Dwg_Entity_INSERT *restrict insert, const double height,
   if (!insobj || err)
     {
       LOG_ERROR ("add_ATTRIB: No INSERT found");
+      API_UNADD_ENTITY;
+      return NULL;
+    }
+  if (!dwg_is_valid_tag (tag))
+    {
+      LOG_ERROR ("add_ATTRIB: Invalid tag %s", tag);
+      API_UNADD_ENTITY;
       return NULL;
     }
   _obj->tag = dwg_add_u8_input (dwg, tag);
@@ -23189,6 +23242,12 @@ dwg_add_ATTDEF (Dwg_Object_BLOCK_HEADER *restrict blkhdr, const double height,
       API_UNADD_ENTITY;
       return NULL;
     }
+  if (!dwg_is_valid_tag (tag))
+    {
+      LOG_ERROR ("add_ATTRIB: Invalid tag %s", tag);
+      API_UNADD_ENTITY;
+      return NULL;
+    }
   ADD_CHECK_3DPOINT (ins_pt);
   ADD_CHECK_DOUBLE (height);
   _obj->prompt = dwg_add_u8_input (dwg, prompt);
